<?php defined('SYSPATH') || die('No direct script access.');

class Model_FinalReport extends Model implements ArrayAccess, Iterator
{
    private $position = 0;
    private $items = [];


    public function __construct($rows) {
        $this->items = array_map(function ($row) {
            return new Model_FinalReportItem($row);
        }, $rows);
    }

    public static function getBySemesterYearNumPlan($year, $num, $plan) {
        $sql = 'SELECT * FROM FinalReport_GetBySemesterYearPlan(:year, :num, :plan)';
        $info = DB::query(Database::SELECT, $sql)
            ->param(':year', $year)
            ->param(':num', $num)
            ->param(':plan', $plan)
            ->execute();

        return new Model_FinalReport($info->as_array());
    }

    public static function getBySemesterYearNumDiscipline($year, $num, $discipline) {
        $sql = 'SELECT * FROM FinalReport_GetBySemesterYearDiscipline(:year, :num, :discipline)';
        $info = DB::query(Database::SELECT, $sql)
            ->param(':year', $year)
            ->param(':num', $num)
            ->param(':discipline', $discipline)
            ->execute();

        return new Model_FinalReport($info->as_array());
    }


    public function offsetSet($offset, $value) {
        if (is_null($offset)) {
            $this->items[] = $value;
        } else {
            $this->items[$offset] = $value;
        }
    }

    public function offsetExists($offset) {
        return isset($this->items[$offset]);
    }

    public function offsetUnset($offset) {
        unset($this->items[$offset]);
    }

    public function offsetGet($offset) {
        return isset($this->items[$offset]) ? $this->items[$offset] : null;
    }


    public function rewind() {
        $this->position = 0;
    }

    public function current() {
        return $this->items[$this->position];
    }

    public function key() {
        return $this->position;
    }

    public function next() {
        ++$this->position;
    }

    public function valid() {
        return isset($this->items[$this->position]);
    }
}
